routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\MasterUsersController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::controller(LoginController::class)->name('login.')->prefix('login')->group(function () {
    Route::get('/', 'index')->name('index');
    Route::post('/request', 'request')->name('request');
});

Route::controller(DashboardController::class)->name('dashboard.')->group(function () {
    Route::get('/dashboard', 'index')->name('index');
});

Route::controller(MasterUsersController::class)->name('masterUsers.')->prefix('master/users')->group(function () {
    Route::get('/', 'index')->name('index');
    Route::get('/create', 'create')->name('create');
    Route::post('/', 'store')->name('store');
    Route::get('/edit/{id}', 'edit')->name('edit');
    Route::put('/{id}', 'update')->name('update');
    Route::delete('/{id}', 'delete')->name('delete');
});

app/Models/MasterUserModel.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class MasterUserModel extends Model
{
    use HasFactory;
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/DashboardController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class DashboardController extends Controller
{
    public function index()
    {
        return view('dashboard.index');
    }

}

app/Http/Controllers/LoginController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class LoginController extends Controller
{
    public function index()
    {
        return view('login.index');
    }

    public function request(Request $request)
    {
        $request->validate([
            'username' => 'required',
            'password' => 'required',
        ]);

        return redirect()->route('login.index')->with('error', 'Login gagal');
    }
}

app/Http/Controllers/MasterUsersController.php
<?php

namespace App\Http\Controllers;

use App\Models\MasterUserModel;
use Illuminate\Http\Request;

class MasterUsersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $data['limit'] = 10;
        $data['search'] = $request->search ? $request->search : '';
        $data['page'] = $request->page ? (int)$request->page : 1;
        $data['offset'] = ($data['page'] > 1) ? ($data['page'] * $data['limit']) - $data['limit'] : 0;
        $data['previous'] = $data['page'] - 1;
        $data['next'] = $data['page'] + 1;
        $data['numbering'] = $data['offset'] + 1;

        $data['pagetotal'] = 10;

        for ($i=0; $i < 5; $i++) {
            $data['users'][$i]['id'] = $i+1;
            $data['users'][$i]['name'] = 'Nama'.$i;
            $data['users'][$i]['username'] = 'Username'.$i;
            $data['users'][$i]['role'] = $i;
            $data['users'][$i]['wilayah'] = $i;
            $data['users'][$i]['status'] = 1;

        }
        return view('masterUser.index', $data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('masterUser.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        echo "CREATE USER";
        dd($request);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\MasterUserModel  $masterUserModel
     * @return \Illuminate\Http\Response
     */
    public function show(MasterUserModel $masterUserModel)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\MasterUserModel  $masterUserModel
     * @return \Illuminate\Http\Response
     */
    public function edit($id, MasterUserModel $masterUserModel)
    {
        $data['user'] = [
            'id' => $id,
            'nama' => 'nama'.$id,
            'alamat' => 'Alamat rumah '.$id,
            'no_telp' => '0812371242',
            'email' => 'email'.$id.'@gmail.com',
            'role' => 2,
            'region' => 3,
            'username' => 'username'.$id,
        ];
        return view('masterUser.edit', $data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\MasterUserModel  $masterUserModel
     * @return \Illuminate\Http\Response
     */
    public function update($id, Request $request, MasterUserModel $masterUserModel)
    {
        echo "UPDATE USER ID = ".$id;
        dd($request);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\MasterUserModel  $masterUserModel
     * @return \Illuminate\Http\Response
     */
    public function delete($id, MasterUserModel $masterUserModel)
    {
        echo "DELETE USERS ID = ".$id;
    }
}

resources/views/login/index.blade.php
@extends('layouts.login')

@section('content')

<div class="d-flex flex-center flex-column flex-column-fluid">
    <!--begin::Wrapper-->
    <div class="w-lg-500px p-10 p-lg-15 mx-auto">
        <!--begin::Form-->
        <form class="form w-100" novalidate="novalidate" id="kt_sign_in_form" action="{{ route('login.request') }}" method="POST">
            @csrf
            <!--begin::Heading-->
            <div class="text-center mb-10">
                <!--begin::Title-->
                <h1 class="text-dark mb-3">Login</h1>
                <!--end::Title-->
            </div>
            <!--begin::Heading-->
            <!--begin::Input group-->
            <div class="fv-row mb-10">
                <!--begin::Label-->
                <label class="form-label fs-6 fw-bolder text-dark">Username</label>
                <!--end::Label-->
                <!--begin::Input-->
                <input class="form-control form-control-lg form-control-solid" type="text" name="username" autocomplete="off" />
                <!--end::Input-->
                @if ($errors->has('username'))
                <span style="color: #f1416c; font-size: .925rem">Username harap diisi</span>
                @endif
            </div>
            <!--end::Input group-->
            <!--begin::Input group-->
            <div class="fv-row mb-10">
                <!--begin::Wrapper-->
                <div class="d-flex flex-stack mb-2">
                    <!--begin::Label-->
                    <label class="form-label fw-bolder text-dark fs-6 mb-0">Password</label>
                    <!--end::Label-->
                </div>
                <!--end::Wrapper-->
                <!--begin::Input-->
                <input class="form-control form-control-lg form-control-solid" type="password" name="password" autocomplete="off" />
                <!--end::Input-->
                @if ($errors->has('password'))
                <span style="color: #f1416c; font-size: .925rem">Username harap diisi</span>
                @endif
            </div>
            <!--end::Input group-->
            <!--begin::Actions-->
            <div class="text-center">
                <!--begin::Submit button-->
                <button type="submit" id="kt_sign_in_submit" class="btn btn-lg btn-primary w-100 mb-5">
                    <span class="indicator-label">Continue</span>
                    <span class="indicator-progress">Please wait...
                    <span class="spinner-border spinner-border-sm align-middle ms-2"></span></span>
                </button>
                <!--end::Submit button-->
            </div>
            <!--end::Actions-->
        </form>
        <!--end::Form-->
    </div>
    <!--end::Wrapper-->
</div>

@endsection

resources/views/masterUser/create.blade.php
@extends('layouts.app')

@section('content')

    <!--begin::Toolbar-->
    <div class="toolbar py-5 py-lg-5" id="kt_toolbar">
        <!--begin::Container-->
        <div id="kt_toolbar_container" class="container-xxl d-flex flex-stack flex-wrap">
            <!--begin::Page title-->
            <div class="page-title d-flex flex-column me-3">
                <!--begin::Title-->
                <h1 class="d-flex text-dark fw-bolder my-1 fs-3">Tambah User</h1>
                <!--end::Title-->
                <!--begin::Breadcrumb-->
                <ul class="breadcrumb breadcrumb-dot fw-bold text-gray-600 fs-7 my-1">
                    <!--begin::Item-->
                    <li class="breadcrumb-item text-gray-600">
                        <a href="#" class="text-gray-600 text-hover-primary">Home</a>
                    </li>
                    <!--end::Item-->
                    @php
                        $numItems = count(request()->segments());
                        $i = 0;
                    @endphp
                    <!--begin::Item-->
                    @foreach (request()->segments() as $item)
                        @if (ucwords($item) == 'Create')
                            <li class="breadcrumb-item {{ ++$i == $numItems ? 'text-gray-500' : 'text-gray-600' }}">
                                Tambah user
                            </li>
                        @elseif (ucwords($item) == 'Edit')
                            <li class="breadcrumb-item text-gray-500">
                                Edit user
                            </li>
                        @elseif (is_numeric($item))
                            @continue
                        @else
                            <li class="breadcrumb-item {{ ++$i == $numItems ? 'text-gray-500' : 'text-gray-600' }}">
                                {{ ucwords($item) }}
                            </li>
                        @endif
                    @endforeach
                    <!--end::Item-->
                </ul>
                <!--end::Breadcrumb-->
            </div>
            <!--end::Page title-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Toolbar-->
    <!--begin::Container-->
    <div id="kt_content_container" class="d-flex flex-column-fluid align-items-start container-xxl">
        <!--begin::Post-->
        <div class="content flex-row-fluid" id="kt_content">
            <!--begin::Card-->
            <div class="card">
                <!--begin::Card body-->
                <div class="card-body">
                    <p>Harap isi data yang telah ditandai dengan <code>*</code>, dan masukkan data dengan benar.</p>
                    <form action="{{ route('masterUsers.store') }}" method="POST" class="my-7">
                        @csrf
                        <div class="row mx-10">
                            <div class="col-md-6">
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Nama</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="text" name="name" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="Nama" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Alamat</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="text" name="alamat" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="Alamat" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">No. Telp</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="text" name="no_telp" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="No. Telp" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Email</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="email" name="email" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="Email" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                            </div>
                            <div class="col-md-6">
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Role</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <select name="role" id="role" class="form-select form-select-solid mb-3 mb-lg-0" required>
                                        <option value="">-- Pilih Role --</option>
                                        <option value="1">1</option>
                                        <option value="2">2</option>
                                        <option value="3">3</option>
                                    </select>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Region</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <select name="region" id="region" class="form-select form-select-solid mb-3 mb-lg-0" required>
                                        <option value="">-- Pilih Region --</option>
                                        <option value="1">1</option>
                                        <option value="2">2</option>
                                        <option value="3">3</option>
                                    </select>
                                    <!--end::Input-->
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Username</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="text" name="username" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="Username" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                                <!--begin::Input group-->
                                <div class="mb-3">
                                    <!--begin::Label-->
                                    <label class="required fw-bold fs-6 mb-2">Password</label>
                                    <!--end::Label-->
                                    <!--begin::Input-->
                                    <input type="password" name="password" class="form-control form-control-solid mb-3 mb-lg-0" placeholder="Password" required/>
                                    <!--end::Input-->
                                </div>
                                <!--end::Input group-->
                            </div>
                            <div class="text-center mt-10">
                                <button type="button" id="batal" class="btn btn-light me-3">Cancel</button>
                                <button type="submit" id="submit" class="btn btn-primary">Simpan</button>
                            </div>
                        </div>
                    </form>
                </div>
                <!--end::Card body-->
            </div>
            <!--end::Card-->
        </div>
        <!--end::Post-->
    </div>
    <!--end::Container-->

@endsection

resources/views/masterUser/index.blade.php
@extends('layouts.app')

@section('content')

    <!--begin::Toolbar-->
    <div class="toolbar py-5 py-lg-5" id="kt_toolbar">
        <!--begin::Container-->
        <div id="kt_toolbar_container" class="container-xxl d-flex flex-stack flex-wrap">
            <!--begin::Page title-->
            <div class="page-title d-flex flex-column me-3">
                <!--begin::Title-->
                <h1 class="d-flex text-dark fw-bolder my-1 fs-3">Users</h1>
                <!--end::Title-->
                <!--begin::Breadcrumb-->
                <ul class="breadcrumb breadcrumb-dot fw-bold text-gray-600 fs-7 my-1">
                    <!--begin::Item-->
                    <li class="breadcrumb-item text-gray-600">
                        <a href="#" class="text-gray-600 text-hover-primary">Home</a>
                    </li>
                    <!--end::Item-->
                    <!--begin::Item-->
                    <li class="breadcrumb-item text-gray-600">Master</li>
                    <!--end::Item-->
                    <!--begin::Item-->
                    <li class="breadcrumb-item text-gray-500">Users</li>
                    <!--end::Item-->
                </ul>
                <!--end::Breadcrumb-->
            </div>
            <!--end::Page title-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Toolbar-->
    <!--begin::Container-->
    <div id="kt_content_container" class="d-flex flex-column-fluid align-items-start container-xxl">
        <!--begin::Post-->
        <div class="content flex-row-fluid" id="kt_content">
            <!--begin::Card-->
            <div class="card">
                <!--begin::Card header-->
                <div class="card-header border-0 pt-6">
                    <!--begin::Card title-->
                    <div class="card-title">
                        <!--begin::Add user-->
                        <a href="{{ route('masterUsers.create') }}" class="btn btn-primary">
                        <!--begin::Svg Icon | path: icons/duotune/arrows/arr075.svg-->
                        <span class="svg-icon svg-icon-2">
                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none">
                                <rect opacity="0.5" x="11.364" y="20.364" width="16" height="2" rx="1" transform="rotate(-90 11.364 20.364)" fill="black" />
                                <rect x="4.36396" y="11.364" width="16" height="2" rx="1" fill="black" />
                            </svg>
                        </span>
                        <!--end::Svg Icon-->Add User</a>
                        <!--end::Add user-->
                    </div>
                    <!--begin::Card title-->
                    <!--begin::Card toolbar-->
                    <div class="card-toolbar">
                        <!--begin::Toolbar-->
                        <div class="d-flex justify-content-end" data-kt-user-table-toolbar="base">
                            <div class="d-flex align-items-center position-relative mt-5">
                                <form action="{{ route('masterUsers.index') }}">
                                <div class="input-group mb-5">
                                        <input type="text" class="form-control" name="search" id="search" placeholder="Search" aria-label="Search" value="{{ $search }}"/>
                                        <button type="submit" class="btn btn-primary"><i class="fas fa-search"></i></button>
                                </div>
                                </form>
                            </div>
                        </div>
                        <!--end::Toolbar-->
                    </div>
                    <!--end::Card toolbar-->
                </div>
                <!--end::Card header-->
                <!--begin::Card body-->
                <div class="card-body pt-0">
                    <!--begin::Table-->
                    <table class="table align-middle table-row-dashed fs-6 gy-5" id="kt_table_users">
                        <!--begin::Table head-->
                        <thead>
                            <!--begin::Table row-->
                            <tr class="text-start text-muted fw-bolder fs-7 text-uppercase gs-0">
                                <th class="min-w-125px">No.</th>
                                <th class="min-w-125px">Nama</th>
                                <th class="min-w-125px">Username</th>
                                <th class="min-w-125px">Role</th>
                                <th class="min-w-125px">Wilayah</th>
                                <th class="min-w-50px">Status</th>
                                <th class="text-center min-w-100px">Actions</th>
                            </tr>
                            <!--end::Table row-->
                        </thead>
                        <!--end::Table head-->
                        <!--begin::Table body-->
                        <tbody class="text-gray-600 fw-bold">
                            @foreach ($users as $user)
                                <tr>
                                    <td>{{ $numbering++ }}</td>
                                    <td>{{ $user['name'] }}</td>
                                    <td>{{ $user['username'] }}</td>
                                    <td>{{ $user['role'] }}</td>
                                    <td>{{ $user['wilayah'] }}</td>
                                    <td>{{ $user['status'] }}</td>
                                    <td class="text-center">
                                        <div class="btn-group" role="group">
                                            <a href="{{ route('masterUsers.edit', $user['id']) }}" class="btn btn-icon icon-left btn-warning" data-bs-toggle="tooltip" data-bs-placement="top" title="Edit"><i class="far fa-edit"></i></a>
                                            <a href="#" class="btn btn-icon icon-left btn-danger" onclick="deleteModal(this)" data-user_id="{{ $user['id'] }}" data-user_name="{{ $user['name'] }}" data-bs-toggle="tooltip" data-bs-placement="top" title="Hapus"><i class="fa fa-trash"></i></a>
                                        </div>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                        <!--end::Table body-->
                    </table>
                    <!--end::Table-->
                    <div class="row mt-10">
                        <ul class="pagination">
                            <li class="page-item previous @if($page == 1) disabled @endif">
                                <a href="{{ route('masterUsers.index', 'search='.$search.'&page='.$previous) }}" class="page-link"><i class="previous"></i></a>
                            </li>
                            @php
                                $start = (($page - 2) > 0) ? $page - 2 : 1;
                                $end = (($page + 2 ) < $pagetotal ) ? $page + 2 : $pagetotal;
                                if ($page < 3) {
                                    $end = 5;
                                }
                                if (($start+5) > $pagetotal) {
                                    $start = $pagetotal - 4;
                                }
                            @endphp
                            @for ($x=$start; $x<=$end; $x++)
                            <li class="page-item @if($page == $x) active @endif">
                                <a href="{{ route('masterUsers.index', 'search='.$search.'&page='.$x) }}" class="page-link">{{ $x }}</a>
                            </li>
                            @endfor
                            <li class="page-item next @if($page == $pagetotal) disabled @endif">
                                <a href="{{ route('masterUsers.index', 'search='.$search.'&page='.$next) }}" class="page-link"><i class="next"></i></a>
                            </li>
                        </ul>
                        <label class="text-center my-5">Halaman ke-{{ $page }} dari {{ $pagetotal }}</label>
                    </div>
                </div>
                <!--end::Card body-->
            </div>
            <!--end::Card-->
        </div>
        <!--end::Post-->
    </div>
    <!--end::Container-->

    {{-- <button type="button" class="btn btn-primary">
        Launch demo modal
    </button> --}}

    <div class="modal fade" tabindex="-1" id="deleteModal">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Warning</h5>

                    <!--begin::Close-->
                    <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
                        <span class="svg-icon svg-icon-2x"></span>
                    </div>
                    <!--end::Close-->
                </div>

                <div class="modal-body">
                </div>

                <div class="modal-footer">
                    <button type="button" class="btn btn-light" data-bs-dismiss="modal">Close</button>
                    <form id="deleteForm" action="" method="POST">
                    @method('delete')
                    @csrf
                    <button type="button" class="btn btn-danger" id="deleteButton">Delete</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    @push('scripts')
    <script type="text/javascript">

        document.getElementById('deleteButton').addEventListener("click", function(e) {
            document.getElementById('deleteButton').innerHTML = "Executing...";
            document.getElementById('deleteButton').disabled = true;
            deleteForm.submit();
        });

        function deleteModal(data) {
            var user_id = $(data).data('user_id');
            var user_name = $(data).data('user_name');
            var formAction = "{{ url('master/users') }}/" + user_id;
            document.getElementById('deleteForm').action = formAction;
            $('#deleteModal .modal-body').html('<p>Anda yakin akan menghapus Users <strong>' + user_name.toUpperCase() + '</strong>?');
            $('#deleteModal').modal('show')
        }

    </script>
    @endpush

@endsection